#!/usr/bin/env python
# -*- encoding: utf-8 -*-
import os
import tempfile
import string
import re
import subprocess
import cups
import time
from subprocess import PIPE, Popen
# import notes_drv
# from cut_line import cut_line as cl


WKF = 'var/spool/cheques/'

ORIGEN = WKF + '/to_print.prn'
BACKUP = WKF + '/bak_che/'

PRINTER = 'LX-350'

BON   = chr(27) + chr(67) + chr(18)  # fija largo de página en ¿ 12 líneas ?
LFCR  = chr(10) + chr(13)            # line feed + carriage return
FF    = chr(12)                      # form feed - new page
RESET = chr(27) + chr(60)            # reset printer
RST   = chr(27) + '!\x00'            # equivalente


PLC = 'SALTO,'  # lugar de emision

MAX = 80    # largo de línea

LC = 13
LN = 44
LP = 9
LM = 3

sp = ' '

litem = len(i)



def cmdline(command):
    process = Popen( args=command, stdout=PIPE, shell=True )
    return process.communicate()[0]

class cherror():
    def __init__(self, err='', msg=''):
        self.err = err
        self.msg = msg

    def prn_err(self):
        message =  "Error - %s" % (self.err, self.msg)
        return message
cherror()

def write_note(nro, note, pp):

    cherr = cherror()
    if not nro:
        raise cherr("Error 001 ", "No hay numero de cheque...")

    num = str(nro)
    amo = note['amount']
    due = note['due_date']
    orn = note['order_to']
    txt = note['amount_txt']
    iss = note['issued_date']

    # transformaciones monto
    amo = amo.replace('.','+')
    amo = amo.replace(',','.').replace('+',',')

    if len(amo) < 18: # fill extra spcace before the ammount with '*'
        amo = (18 - len(amo))*'*' + amo
    amo = (67 - len(amo) )*' ' + amo


    # escribir el cheque
    # pp.write( BON )
    pp.write( RESET )
    pp.write( chr(27) + chr(67) + chr(0) +  chr(3) ) # largo pagina 3 pulgadas
    pp.write( chr(27) + chr(50) ) # espacio entre lineas a 1/6 (normal)
    pp.write(chr(27) + chr(77))
    pp.write( chr(15) ) # condensed on
    pp.write( chr(14) ) # caracter doble on
    pp.write( amo )
    pp.write( chr(20) ) # caracter doble off
    pp.write( LFCR )    # line feed + carriage return
    pp.write( chr(18) ) # letra condesada off

    pp.write(chr(27) + chr(80)) # 10 cpi on
    pp.write( LFCR + 28*' ' + num + LFCR )
    pp.write(chr(27) + chr(77)) # 12 cpi on

    pp.write( chr(18) ) # letra condesada off
    pp.write( chr(15) ) # condensed on
    pp.write( chr(14) ) # caracter doble on
    pp.write( 56*' ' + vto + LFCR )
    pp.write( chr(20) ) # caracter doble off
    pp.write( chr(18) ) # letra condesada off

    pp.write(chr(27) + chr(80)) # 10 cpi on
    pp.write(  3*' ' + orn + LFCR )
    pp.write(chr(27) + chr(77)) # 12 cpi on

    pp.write(chr(27) + chr(49)) # espeacio entre lineas a 7/72
    pp.write( LFCR )            # line feed + carriage return
    pp.write(chr(27) + chr(50)) # espeacio entre lineas a 1/6 (normal)

    pp.write( chr(18) ) # letra condesada off
    pp.write( lt1 + LFCR + 2*' ' + lt2 )
    pp.write( chr(13) ) # carriage return

    pp.write( chr(15) ) # condensed on
    pp.write( chr(14) ) # caracter doble on
    pp.write( chr(13) ) # carriage return
    pp.write( 36*' ' + PLC + 14*' '+ emi )
    #pp.write(chr(27) + chr(77)) # 12 cpi on
    #pp.write( chr(18) ) # letra condesada off
    pp.write( FF )      # form feed - new page


def main( ):
    # lee el origen desde una cola de impresión
    # devuelve un objeto con los datos reestructurados
    origin = notes_drv.Ch(ORIGEN)
    inputstr = origin.split_lines()
    ches = {}

    # en tanto la llave es el numero de cheque, en el diccionario
    # resultante no hay cheques duplicados.
    for cont in range(len(inputstr)):
        ches.update(origin.parse_note(inputstr[cont]))

    kk = ches.keys()
    kk.sort()

    filePrint = "/tmp/print_ch"

    to_print = open(filePrint,"w")

    for i in kk:
        write_note( str(i), ches[i], to_print )
    to_print.close()

    salida = os.system('lp %s' % filePrint)

    conn = cups.Connection()
    print_response = conn.printFile(PRINTER, to_print, '<:>>>>>>>>>>  «to_print» file sent to print.', {})
    stop = 0
    TIMEOUT = 60
    while str(subprocess.check_output(["lpstat"])).find(str(print_response)) > 0 and stop < TIMEOUT:
        stop+= 1
        time.sleep(1)
    if stop < TIMEOUT:
        print "PRINT SUCCESS"
        # print "respaldar y borrar origen"
        ext = cmdline('date +%Y-%m-%d_%H:%M:%S')
        cmdline("cp %s %s%s" % (filePrint,BACKUP,ext[:-1]))
    else:
        print "PRINT FAILURE"


if __name__ == '__main__':
    main()
