# -*- coding: utf=8 -*-

#import ipdb

from time import strftime

def paginate(data):

    """
        Arma  y compagina del informe
        :param:  list of lines
        :return: big string report
    """
    FF    = chr(12)     # form feed - new page

    LxP = 57.0
    lines = len(data)
    pages = lines / LxP
    pages = int(pages) if pages%1 == 0 else int(pages)+1
    stime = lambda *x: strftime("%0d/%0m/%Y %0H:%M")

    head_pag = "LISTADO DE CAMBIO DE PRECIOS " + " " * 31

    ulh = "-" # subrayado cabezal                          [¯]  175  10/15  257  AF  MACRON
    ulf = "=" # subrayado pie pag                          [·]  183  11/07  267  B7  MIDDLE DOT
                                    #                      [=]   61  03/13   75  3D
    HeaderMain = head_pag + stime() + "\n" + 76 * ulh + "\n"

    to_file = HeaderMain

    pag = 1
    jump = 1
    for i in data:

        if jump % LxP == 0:
            foot =  "Pag. %s de %s" % (pag, pages)
            Footer =  76 * ulf + "\n" + (76 - len(foot)) * " " + foot + "\n"
            to_file += Footer + FF

            Header = head_pag + stime() + "\n" + 76 * ulh + "\n"
            to_file += Header

            pag += 1

        to_file += i
        to_file += '\n'
        jump += 1

    lines += 100

    for i in range(lines-jump):
        if (i != 0) and ((i+1) % 57.0) == 0:
            break
    to_file += (i-1) * '\n' # lineas que faltan para el jump

    foot =  "Pag. %s de %s" % (pag, pages)
    Footer =  76 * ulf + "\n" + (76 - len(foot)) * " " + foot + "\n"
    to_file += Footer + FF

    result = to_file

    return result

def do_report(data_input=None):
    """
         :param     :data_input :type:str     csv like formatted string, sep "|"
         :returns   :res    :type:list    to be printed formatted big string
    """
    if not data_input: return False



    unidata = data_input #.encode('utf-8')

    #           Largo de campos
    LC = 13     #  codigo
    LN = 44     #  nombre
    LP =  9     #  precio
    LM =  3     #  unidad de medida

    SP = ' '    #  separador para campos de impresion
    SEP2 = 2
    SEP3 = 3
    report = []
    #                 (largo maximo del campo, largo separador, justificacion)
    fields_metadata = {0: (LC,SEP2,'l'), 1: (LN,SEP3,'r'), 2: (LP,SEP2,'l'), 3: (LM,SEP2,'l')}

    lines = unidata.splitlines()         # separa el string de entrada en líneas
    for line in lines:

        # each field to string, each line list of str member
        line = line.split('|')

        # format the line
        report_line = ''
        for j in range(len(fields_metadata)): # ( largo maximo - largo real ) * SP + campo +  SPC

            field = ''
            line_data = line[j].strip()
            meta = fields_metadata[ j ]

            if meta[2] == 'r':  # justificado a derecha
                field += line_data + (meta[0] - len(line_data)) * SP
            else:
                field += (meta[0] - len(line_data)) * SP + line_data

            report_line += field + meta[1] * SP

        # report_line = report_line.decode('utf-8')
        report.append( report_line) #.encode('cp850')  )

    return report

def main_report(data_in):

    report = do_report(data_in)
    data_output = paginate(report)
    return data_output

if __name__ == '__main__':
    main_report(data_in)



